import 'dart:async';
import '../../osam_flutter.dart';

part 'osam_route.g.dart';

@HiveType(typeId: 222)
class OsamRoute<A, R> {
  @HiveField(0)
  final String value;
  @HiveField(1)
  final A argument;
  @HiveField(2)
  R result;
  final _completer = Completer<R>();

  void complete() => _completer.complete(result);

  Future<R> get whenComplete => _completer.future;

  OsamRoute(this.value, {this.argument, this.result});

  @override
  bool operator ==(other) => value == other.value;


  @override
  String toString() => 'Route is $value with result: ${result.toString}';

  @override
  int get hashCode => value.hashCode;
}
